package bookExamples.ch26Graphics.draw2d;

import java.awt.*;

public abstract class Shape extends Component
        implements Paintable {
    int x1 = 0;
    int y1 = 0;
    int x2 = 1;
    int y2 = 1;

    public abstract Shape getInstance(int x1, int y1, int x2, int y2);

    public void setLocation(int x1, int y1, int x2, int y2) {
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
    }

    public Shape(int x1, int y1, int x2, int y2) {
        this.x1 = x1;
        this.x2 = x2;
        this.y1 = y1;
        this.y2 = y2;
    }

    public void erase(Frame f, Graphics g) {
        g.setXORMode(f.getBackground());
        paint(g);
        g.setColor(f.getForeground());
        g.setPaintMode();
    }

    public void setX1(int x1) {
        this.x1 = x1;
    }

    public void setY1(int y1) {
        this.y1 = y1;
    }

    public void setX2(int x2) {
        this.x2 = x2;
    }

    public void setY2(int y2) {
        this.y2 = y2;
    }
}